#include "Mikromedia_4_Demo_objects.h"
#include "Mikromedia_4_Demo_resources.h"
#include "built_in.h"

// Extern memory interface
// MMC/SD Connections
sbit Mmc_Chip_Select           at GPIOD_ODR.B2;
// end of MMC/SD
// VTFT Get Data globals
unsigned long currentSector = -1, res_file_size;
short rfHandle;
char* rfName;
unsigned long rfStartSect;
// end of TFT Get Data
// End of extern memory interface


// TFT module connections
sbit TFT_BLED at GPIOF_ODR.B10;
sbit TFT_CS at GPIOF_ODR.B13;
unsigned int TFT_DataPort at GPIOE_ODR;
sbit TFT_RD at GPIOF_ODR.B12;
sbit TFT_RS at GPIOF_ODR.B15;
sbit TFT_RST at GPIOF_ODR.B14;
sbit TFT_WR at GPIOF_ODR.B11;
// End TFT module connections

// Touch Panel module connections
// End Touch Panel module connections

// Global variables
unsigned int Xcoord, Ycoord;
char PenDown;
void *PressedObject;
int PressedObjectType;
unsigned int caption_length, caption_height;
unsigned int display_width, display_height;

int _object_count;
unsigned short object_pressed;
TButton *local_button;
TButton *exec_button;
int button_order;
TLabel *local_label;
TLabel *exec_label;
int label_order;
TImage *local_image;
TImage *exec_image;
int image_order;


void Write_to_Data_Lines(unsigned char _hi, unsigned char _lo) {
  GPIOE_ODR = (unsigned int) (_lo | (_hi << 8));
}

void Set_Index(unsigned short index) {
  TFT_RS = 0;
  Write_to_Data_Lines(0, index);
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

void Write_Command(unsigned short cmd) {
  TFT_RS = 1;
  Write_to_Data_Lines(0, cmd);
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}

void Write_Data(unsigned int _data) {
  TFT_RS = 1;
  Write_to_Data_Lines(Hi(_data), Lo(_data));
  TFT_WR = 0;
  asm nop;
  TFT_WR = 1;
}


char *TFT_Get_Data(unsigned long fPos, unsigned long bytesToGet, unsigned long *pBytesGot) {
  unsigned int  scOffset;

  *pBytesGot = 0;

  if (rfHandle < 0) {
    return 0; // return with nil if handle was bad.
  }

  // We will utilize some of the fat32 implied features
  // (such as built in sector buffer) to reduce ram memory consumpiton.
  // You can't use this approach if this buffer is going to be used
  // from another thread (i.e. using fat32 routines in interrupt...)
  // In that case or if you have plenty of ram memory use separate
  // as large as possible data buffer.
  f32_sector.fSectNum = rfStartSect + fPos / 512;
  Mmc_Read_Sector(f32_sector.fSectNum, f32_sector.fSect);

  // 512 bytes sector buffer implied.
  scOffset = fPos % 512;
  if(bytesToGet > 512-scOffset)
    *pBytesGot = 512-scOffset;
  else
    *pBytesGot = bytesToGet;

  return &f32_sector.fSect + scOffset;
}
static void InitializeTouchPanel() {
  TFT_Set_Active(Set_Index, Write_Command, Write_Data);
  TFT_Init_SSD1963_Board_43(480, 272);
  TFT_Set_Ext_Buffer(TFT_Get_Data);

  TFT_Set_DBC_SSD1963(255);

  PenDown = 0;
  PressedObject = 0;
  PressedObjectType = -1;
}


/////////////////////////
  TScreen*  CurrentScreen;

  TScreen                Screen_00_MAIN;
  TImage               Image_00_00_MAIN;
  TButton               Button_00_01_INDOOR;
char Button_00_01_INDOOR_Caption[1] = "";

  TButton               Button_00_02_MP3;
char Button_00_02_MP3_Caption[1] = "";

  TButton               Button_00_03_ACCEL;
char Button_00_03_ACCEL_Caption[1] = "";

  TButton               Button_00_09_PREV;
char Button_00_09_PREV_Caption[1] = "";

  TButton               Button_00_04_PLAY;
char Button_00_04_PLAY_Caption[1] = "";

  TButton               Button_00_08_NEXT;
char Button_00_08_NEXT_Caption[1] = "";

  TButton               Button_00_06_VOL_INC;
char Button_00_06_VOL_INC_Caption[1] = "";

  TButton               Button_00_07_VOL_DEC;
char Button_00_07_VOL_DEC_Caption[1] = "";

  TButton               Button_00_05_MUTE;
char Button_00_05_MUTE_Caption[1] = "";

  TButton                * const code Screen_00_MAIN_Buttons[9]=
         {
         &Button_00_01_INDOOR, 
         &Button_00_02_MP3,    
         &Button_00_03_ACCEL,  
         &Button_00_09_PREV,   
         &Button_00_04_PLAY,   
         &Button_00_08_NEXT,   
         &Button_00_06_VOL_INC,
         &Button_00_07_VOL_DEC,
         &Button_00_05_MUTE    
         };
  TImage                 * const code Screen_00_MAIN_Images[1]=
         {
         &Image_00_00_MAIN     
         };

  TScreen                Screen_01_INDOOR;
  TImage               Image_00_02_INDOOR;
  TLabel                 Label_00_00_Indoor_Temperature;
char Label_00_00_Indoor_Temperature_Caption[60] = "|                                                          ";

  TLabel                 Label_00_01_Indoor_Ambient_Light_CH0;
char Label_00_01_Indoor_Ambient_Light_CH0_Caption[60] = "|                                                          ";

  TLabel                 Label_00_01_Indoor_Ambient_Light_CH1;
char Label_00_01_Indoor_Ambient_Light_CH1_Caption[60] = "|                                                          ";

  TLabel                 * const code Screen_01_INDOOR_Labels[3]=
         {
         &Label_00_00_Indoor_Temperature,
         &Label_00_01_Indoor_Ambient_Light_CH0,
         &Label_00_01_Indoor_Ambient_Light_CH1
         };
  TImage                 * const code Screen_01_INDOOR_Images[1]=
         {
         &Image_00_02_INDOOR   
         };

  TScreen                Screen_03_MP3;
  TImage               Image_00_03_MP3;
  TImage                 * const code Screen_03_MP3_Images[1]=
         {
         &Image_00_03_MP3      
         };

  TScreen                Screen_04_ACCEL;
  TImage               Image_00_04_ACCEL;
  TLabel                 Label_00_06_Accel_X_Axis;
char Label_00_06_Accel_X_Axis_Caption[30] = "|                            ";

  TLabel                 Label_00_07_Accel_Y_Axis;
char Label_00_07_Accel_Y_Axis_Caption[30] = "|                            ";

  TLabel                 Label_00_08_Accel_Z_Axis;
char Label_00_08_Accel_Z_Axis_Caption[30] = "|                            ";

  TLabel                 * const code Screen_04_ACCEL_Labels[3]=
         {
         &Label_00_06_Accel_X_Axis,
         &Label_00_07_Accel_Y_Axis,
         &Label_00_08_Accel_Z_Axis
         };
  TImage                 * const code Screen_04_ACCEL_Images[1]=
         {
         &Image_00_04_ACCEL    
         };



static void InitializeObjects() {
  Screen_00_MAIN.Color                     = 0x0000;
  Screen_00_MAIN.Width                     = 480;
  Screen_00_MAIN.Height                    = 272;
  Screen_00_MAIN.ButtonsCount              = 9;
  Screen_00_MAIN.Buttons                   = Screen_00_MAIN_Buttons;
  Screen_00_MAIN.LabelsCount               = 0;
  Screen_00_MAIN.ImagesCount               = 1;
  Screen_00_MAIN.Images                    = Screen_00_MAIN_Images;
  Screen_00_MAIN.ObjectsCount              = 10;
  Screen_00_MAIN.OnSwipeUpPtr    = 0;
  Screen_00_MAIN.OnSwipeDownPtr  = 0;
  Screen_00_MAIN.OnSwipeLeftPtr  = 0;
  Screen_00_MAIN.OnSwipeRightPtr = 0;
  Screen_00_MAIN.OnZoomInPtr     = 0;
  Screen_00_MAIN.OnZoomOutPtr    = 0;

  Screen_01_INDOOR.Color                     = 0x0000;
  Screen_01_INDOOR.Width                     = 480;
  Screen_01_INDOOR.Height                    = 272;
  Screen_01_INDOOR.ButtonsCount              = 0;
  Screen_01_INDOOR.LabelsCount               = 3;
  Screen_01_INDOOR.Labels                    = Screen_01_INDOOR_Labels;
  Screen_01_INDOOR.ImagesCount               = 1;
  Screen_01_INDOOR.Images                    = Screen_01_INDOOR_Images;
  Screen_01_INDOOR.ObjectsCount              = 4;
  Screen_01_INDOOR.OnSwipeUpPtr    = 0;
  Screen_01_INDOOR.OnSwipeDownPtr  = 0;
  Screen_01_INDOOR.OnSwipeLeftPtr  = 0;
  Screen_01_INDOOR.OnSwipeRightPtr = 0;
  Screen_01_INDOOR.OnZoomInPtr     = 0;
  Screen_01_INDOOR.OnZoomOutPtr    = 0;

  Screen_03_MP3.Color                     = 0x0000;
  Screen_03_MP3.Width                     = 480;
  Screen_03_MP3.Height                    = 272;
  Screen_03_MP3.ButtonsCount              = 0;
  Screen_03_MP3.LabelsCount               = 0;
  Screen_03_MP3.ImagesCount               = 1;
  Screen_03_MP3.Images                    = Screen_03_MP3_Images;
  Screen_03_MP3.ObjectsCount              = 1;
  Screen_03_MP3.OnSwipeUpPtr    = 0;
  Screen_03_MP3.OnSwipeDownPtr  = 0;
  Screen_03_MP3.OnSwipeLeftPtr  = 0;
  Screen_03_MP3.OnSwipeRightPtr = 0;
  Screen_03_MP3.OnZoomInPtr     = 0;
  Screen_03_MP3.OnZoomOutPtr    = 0;

  Screen_04_ACCEL.Color                     = 0x0000;
  Screen_04_ACCEL.Width                     = 480;
  Screen_04_ACCEL.Height                    = 272;
  Screen_04_ACCEL.ButtonsCount              = 0;
  Screen_04_ACCEL.LabelsCount               = 3;
  Screen_04_ACCEL.Labels                    = Screen_04_ACCEL_Labels;
  Screen_04_ACCEL.ImagesCount               = 1;
  Screen_04_ACCEL.Images                    = Screen_04_ACCEL_Images;
  Screen_04_ACCEL.ObjectsCount              = 4;
  Screen_04_ACCEL.OnSwipeUpPtr    = 0;
  Screen_04_ACCEL.OnSwipeDownPtr  = 0;
  Screen_04_ACCEL.OnSwipeLeftPtr  = 0;
  Screen_04_ACCEL.OnSwipeRightPtr = 0;
  Screen_04_ACCEL.OnZoomInPtr     = 0;
  Screen_04_ACCEL.OnZoomOutPtr    = 0;


  Image_00_00_MAIN.OwnerScreen     = &Screen_00_MAIN;
  Image_00_00_MAIN.Order           = 0;
  Image_00_00_MAIN.Left            = 0;
  Image_00_00_MAIN.Top             = 0;
  Image_00_00_MAIN.Width           = 480;
  Image_00_00_MAIN.Height          = 272;
  Image_00_00_MAIN.Picture_Type    = 0;
  Image_00_00_MAIN.Picture_Ratio   = 1;
  Image_00_00_MAIN.Picture_Name    = Image_00_00_MAIN_bmp;
  Image_00_00_MAIN.Visible         = 1;
  Image_00_00_MAIN.Active          = 1;

  Button_00_01_INDOOR.OwnerScreen     = &Screen_00_MAIN;
  Button_00_01_INDOOR.Order           = 1;
  Button_00_01_INDOOR.Left            = 289;
  Button_00_01_INDOOR.Top             = 24;
  Button_00_01_INDOOR.Width           = 96;
  Button_00_01_INDOOR.Height          = 97;
  Button_00_01_INDOOR.Pen_Width       = 0;
  Button_00_01_INDOOR.Pen_Color       = 0x0000;
  Button_00_01_INDOOR.Visible         = 1;
  Button_00_01_INDOOR.Active          = 1;
  Button_00_01_INDOOR.Transparent     = 0;
  Button_00_01_INDOOR.Caption         = Button_00_01_INDOOR_Caption;
  Button_00_01_INDOOR.TextAlign       = _taCenter;
  Button_00_01_INDOOR.TextAlignVertical= _tavMiddle;
  Button_00_01_INDOOR.FontName        = Tahoma11x13_Regular;
  Button_00_01_INDOOR.PressColEnabled = 0;
  Button_00_01_INDOOR.Font_Color      = 0x0000;
  Button_00_01_INDOOR.VerticalText    = 0;
  Button_00_01_INDOOR.Gradient        = 0;
  Button_00_01_INDOOR.Gradient_Orientation = 0;
  Button_00_01_INDOOR.Gradient_Start_Color = 0xFFFF;
  Button_00_01_INDOOR.Gradient_End_Color = 0xC618;
  Button_00_01_INDOOR.Color           = 0xC618;
  Button_00_01_INDOOR.Press_Color     = 0xE71C;
  Button_00_01_INDOOR.OnClickPtr      = Button_00_01_INDOOR_OnClick;

  Button_00_02_MP3.OwnerScreen     = &Screen_00_MAIN;
  Button_00_02_MP3.Order           = 2;
  Button_00_02_MP3.Left            = 241;
  Button_00_02_MP3.Top             = 128;
  Button_00_02_MP3.Width           = 96;
  Button_00_02_MP3.Height          = 97;
  Button_00_02_MP3.Pen_Width       = 0;
  Button_00_02_MP3.Pen_Color       = 0x0000;
  Button_00_02_MP3.Visible         = 1;
  Button_00_02_MP3.Active          = 1;
  Button_00_02_MP3.Transparent     = 0;
  Button_00_02_MP3.Caption         = Button_00_02_MP3_Caption;
  Button_00_02_MP3.TextAlign       = _taCenter;
  Button_00_02_MP3.TextAlignVertical= _tavMiddle;
  Button_00_02_MP3.FontName        = Tahoma11x13_Regular;
  Button_00_02_MP3.PressColEnabled = 0;
  Button_00_02_MP3.Font_Color      = 0x0000;
  Button_00_02_MP3.VerticalText    = 0;
  Button_00_02_MP3.Gradient        = 0;
  Button_00_02_MP3.Gradient_Orientation = 0;
  Button_00_02_MP3.Gradient_Start_Color = 0xFFFF;
  Button_00_02_MP3.Gradient_End_Color = 0xC618;
  Button_00_02_MP3.Color           = 0xC618;
  Button_00_02_MP3.Press_Color     = 0xE71C;
  Button_00_02_MP3.OnClickPtr      = Button_00_02_MP3_OnClick;

  Button_00_03_ACCEL.OwnerScreen     = &Screen_00_MAIN;
  Button_00_03_ACCEL.Order           = 3;
  Button_00_03_ACCEL.Left            = 348;
  Button_00_03_ACCEL.Top             = 128;
  Button_00_03_ACCEL.Width           = 96;
  Button_00_03_ACCEL.Height          = 97;
  Button_00_03_ACCEL.Pen_Width       = 0;
  Button_00_03_ACCEL.Pen_Color       = 0x0000;
  Button_00_03_ACCEL.Visible         = 1;
  Button_00_03_ACCEL.Active          = 1;
  Button_00_03_ACCEL.Transparent     = 0;
  Button_00_03_ACCEL.Caption         = Button_00_03_ACCEL_Caption;
  Button_00_03_ACCEL.TextAlign       = _taCenter;
  Button_00_03_ACCEL.TextAlignVertical= _tavMiddle;
  Button_00_03_ACCEL.FontName        = Tahoma11x13_Regular;
  Button_00_03_ACCEL.PressColEnabled = 0;
  Button_00_03_ACCEL.Font_Color      = 0x0000;
  Button_00_03_ACCEL.VerticalText    = 0;
  Button_00_03_ACCEL.Gradient        = 0;
  Button_00_03_ACCEL.Gradient_Orientation = 0;
  Button_00_03_ACCEL.Gradient_Start_Color = 0xFFFF;
  Button_00_03_ACCEL.Gradient_End_Color = 0xC618;
  Button_00_03_ACCEL.Color           = 0xC618;
  Button_00_03_ACCEL.Press_Color     = 0xE71C;
  Button_00_03_ACCEL.OnClickPtr      = Button_00_03_ACCEL_OnClick;

  Button_00_09_PREV.OwnerScreen     = &Screen_00_MAIN;
  Button_00_09_PREV.Order           = 4;
  Button_00_09_PREV.Left            = 50;
  Button_00_09_PREV.Top             = 65;
  Button_00_09_PREV.Width           = 50;
  Button_00_09_PREV.Height          = 50;
  Button_00_09_PREV.Pen_Width       = 0;
  Button_00_09_PREV.Pen_Color       = 0x0000;
  Button_00_09_PREV.Visible         = 1;
  Button_00_09_PREV.Active          = 1;
  Button_00_09_PREV.Transparent     = 0;
  Button_00_09_PREV.Caption         = Button_00_09_PREV_Caption;
  Button_00_09_PREV.TextAlign       = _taCenter;
  Button_00_09_PREV.TextAlignVertical= _tavMiddle;
  Button_00_09_PREV.FontName        = Tahoma11x13_Regular;
  Button_00_09_PREV.PressColEnabled = 0;
  Button_00_09_PREV.Font_Color      = 0x0000;
  Button_00_09_PREV.VerticalText    = 0;
  Button_00_09_PREV.Gradient        = 0;
  Button_00_09_PREV.Gradient_Orientation = 0;
  Button_00_09_PREV.Gradient_Start_Color = 0xFFFF;
  Button_00_09_PREV.Gradient_End_Color = 0xC618;
  Button_00_09_PREV.Color           = 0xC618;
  Button_00_09_PREV.Press_Color     = 0xE71C;
  Button_00_09_PREV.OnClickPtr      = Button_00_09_PREV_OnClick;

  Button_00_04_PLAY.OwnerScreen     = &Screen_00_MAIN;
  Button_00_04_PLAY.Order           = 5;
  Button_00_04_PLAY.Left            = 100;
  Button_00_04_PLAY.Top             = 65;
  Button_00_04_PLAY.Width           = 50;
  Button_00_04_PLAY.Height          = 50;
  Button_00_04_PLAY.Pen_Width       = 0;
  Button_00_04_PLAY.Pen_Color       = 0x0000;
  Button_00_04_PLAY.Visible         = 1;
  Button_00_04_PLAY.Active          = 1;
  Button_00_04_PLAY.Transparent     = 0;
  Button_00_04_PLAY.Caption         = Button_00_04_PLAY_Caption;
  Button_00_04_PLAY.TextAlign       = _taCenter;
  Button_00_04_PLAY.TextAlignVertical= _tavMiddle;
  Button_00_04_PLAY.FontName        = Tahoma11x13_Regular;
  Button_00_04_PLAY.PressColEnabled = 0;
  Button_00_04_PLAY.Font_Color      = 0x0000;
  Button_00_04_PLAY.VerticalText    = 0;
  Button_00_04_PLAY.Gradient        = 0;
  Button_00_04_PLAY.Gradient_Orientation = 0;
  Button_00_04_PLAY.Gradient_Start_Color = 0xFFFF;
  Button_00_04_PLAY.Gradient_End_Color = 0xC618;
  Button_00_04_PLAY.Color           = 0xC618;
  Button_00_04_PLAY.Press_Color     = 0xE71C;
  Button_00_04_PLAY.OnClickPtr      = Button_00_04_PLAY_OnClick;

  Button_00_08_NEXT.OwnerScreen     = &Screen_00_MAIN;
  Button_00_08_NEXT.Order           = 6;
  Button_00_08_NEXT.Left            = 150;
  Button_00_08_NEXT.Top             = 65;
  Button_00_08_NEXT.Width           = 50;
  Button_00_08_NEXT.Height          = 50;
  Button_00_08_NEXT.Pen_Width       = 0;
  Button_00_08_NEXT.Pen_Color       = 0x0000;
  Button_00_08_NEXT.Visible         = 1;
  Button_00_08_NEXT.Active          = 1;
  Button_00_08_NEXT.Transparent     = 0;
  Button_00_08_NEXT.Caption         = Button_00_08_NEXT_Caption;
  Button_00_08_NEXT.TextAlign       = _taCenter;
  Button_00_08_NEXT.TextAlignVertical= _tavMiddle;
  Button_00_08_NEXT.FontName        = Tahoma11x13_Regular;
  Button_00_08_NEXT.PressColEnabled = 0;
  Button_00_08_NEXT.Font_Color      = 0x0000;
  Button_00_08_NEXT.VerticalText    = 0;
  Button_00_08_NEXT.Gradient        = 0;
  Button_00_08_NEXT.Gradient_Orientation = 0;
  Button_00_08_NEXT.Gradient_Start_Color = 0xFFFF;
  Button_00_08_NEXT.Gradient_End_Color = 0xC618;
  Button_00_08_NEXT.Color           = 0xC618;
  Button_00_08_NEXT.Press_Color     = 0xE71C;
  Button_00_08_NEXT.OnClickPtr      = Button_00_08_NEXT_OnClick;

  Button_00_06_VOL_INC.OwnerScreen     = &Screen_00_MAIN;
  Button_00_06_VOL_INC.Order           = 7;
  Button_00_06_VOL_INC.Left            = 50;
  Button_00_06_VOL_INC.Top             = 143;
  Button_00_06_VOL_INC.Width           = 50;
  Button_00_06_VOL_INC.Height          = 50;
  Button_00_06_VOL_INC.Pen_Width       = 0;
  Button_00_06_VOL_INC.Pen_Color       = 0x0000;
  Button_00_06_VOL_INC.Visible         = 1;
  Button_00_06_VOL_INC.Active          = 1;
  Button_00_06_VOL_INC.Transparent     = 0;
  Button_00_06_VOL_INC.Caption         = Button_00_06_VOL_INC_Caption;
  Button_00_06_VOL_INC.TextAlign       = _taCenter;
  Button_00_06_VOL_INC.TextAlignVertical= _tavMiddle;
  Button_00_06_VOL_INC.FontName        = Tahoma11x13_Regular;
  Button_00_06_VOL_INC.PressColEnabled = 0;
  Button_00_06_VOL_INC.Font_Color      = 0x0000;
  Button_00_06_VOL_INC.VerticalText    = 0;
  Button_00_06_VOL_INC.Gradient        = 0;
  Button_00_06_VOL_INC.Gradient_Orientation = 0;
  Button_00_06_VOL_INC.Gradient_Start_Color = 0xFFFF;
  Button_00_06_VOL_INC.Gradient_End_Color = 0xC618;
  Button_00_06_VOL_INC.Color           = 0xC618;
  Button_00_06_VOL_INC.Press_Color     = 0xE71C;
  Button_00_06_VOL_INC.OnClickPtr      = Button_00_06_VOL_INC_OnClick;

  Button_00_07_VOL_DEC.OwnerScreen     = &Screen_00_MAIN;
  Button_00_07_VOL_DEC.Order           = 8;
  Button_00_07_VOL_DEC.Left            = 100;
  Button_00_07_VOL_DEC.Top             = 143;
  Button_00_07_VOL_DEC.Width           = 50;
  Button_00_07_VOL_DEC.Height          = 50;
  Button_00_07_VOL_DEC.Pen_Width       = 0;
  Button_00_07_VOL_DEC.Pen_Color       = 0x0000;
  Button_00_07_VOL_DEC.Visible         = 1;
  Button_00_07_VOL_DEC.Active          = 1;
  Button_00_07_VOL_DEC.Transparent     = 0;
  Button_00_07_VOL_DEC.Caption         = Button_00_07_VOL_DEC_Caption;
  Button_00_07_VOL_DEC.TextAlign       = _taCenter;
  Button_00_07_VOL_DEC.TextAlignVertical= _tavMiddle;
  Button_00_07_VOL_DEC.FontName        = Tahoma11x13_Regular;
  Button_00_07_VOL_DEC.PressColEnabled = 0;
  Button_00_07_VOL_DEC.Font_Color      = 0x0000;
  Button_00_07_VOL_DEC.VerticalText    = 0;
  Button_00_07_VOL_DEC.Gradient        = 0;
  Button_00_07_VOL_DEC.Gradient_Orientation = 0;
  Button_00_07_VOL_DEC.Gradient_Start_Color = 0xFFFF;
  Button_00_07_VOL_DEC.Gradient_End_Color = 0xC618;
  Button_00_07_VOL_DEC.Color           = 0xC618;
  Button_00_07_VOL_DEC.Press_Color     = 0xE71C;
  Button_00_07_VOL_DEC.OnClickPtr      = Button_00_07_VOL_DEC_OnClick;

  Button_00_05_MUTE.OwnerScreen     = &Screen_00_MAIN;
  Button_00_05_MUTE.Order           = 9;
  Button_00_05_MUTE.Left            = 150;
  Button_00_05_MUTE.Top             = 143;
  Button_00_05_MUTE.Width           = 50;
  Button_00_05_MUTE.Height          = 50;
  Button_00_05_MUTE.Pen_Width       = 0;
  Button_00_05_MUTE.Pen_Color       = 0x0000;
  Button_00_05_MUTE.Visible         = 1;
  Button_00_05_MUTE.Active          = 1;
  Button_00_05_MUTE.Transparent     = 0;
  Button_00_05_MUTE.Caption         = Button_00_05_MUTE_Caption;
  Button_00_05_MUTE.TextAlign       = _taCenter;
  Button_00_05_MUTE.TextAlignVertical= _tavMiddle;
  Button_00_05_MUTE.FontName        = Tahoma11x13_Regular;
  Button_00_05_MUTE.PressColEnabled = 0;
  Button_00_05_MUTE.Font_Color      = 0x0000;
  Button_00_05_MUTE.VerticalText    = 0;
  Button_00_05_MUTE.Gradient        = 0;
  Button_00_05_MUTE.Gradient_Orientation = 0;
  Button_00_05_MUTE.Gradient_Start_Color = 0xFFFF;
  Button_00_05_MUTE.Gradient_End_Color = 0xC618;
  Button_00_05_MUTE.Color           = 0xC618;
  Button_00_05_MUTE.Press_Color     = 0xE71C;
  Button_00_05_MUTE.OnClickPtr      = Button_00_05_MUTE_OnClick;

  Image_00_02_INDOOR.OwnerScreen     = &Screen_01_INDOOR;
  Image_00_02_INDOOR.Order           = 0;
  Image_00_02_INDOOR.Left            = 29;
  Image_00_02_INDOOR.Top             = 25;
  Image_00_02_INDOOR.Width           = 193;
  Image_00_02_INDOOR.Height          = 200;
  Image_00_02_INDOOR.Picture_Type    = 0;
  Image_00_02_INDOOR.Picture_Ratio   = 1;
  Image_00_02_INDOOR.Picture_Name    = Image_00_02_INDOOR_bmp;
  Image_00_02_INDOOR.Visible         = 1;
  Image_00_02_INDOOR.Active          = 1;

  Label_00_00_Indoor_Temperature.OwnerScreen     = &Screen_01_INDOOR;
  Label_00_00_Indoor_Temperature.Order           = 1;
  Label_00_00_Indoor_Temperature.Left            = 85;
  Label_00_00_Indoor_Temperature.Top             = 84;
  Label_00_00_Indoor_Temperature.Width           = 9;
  Label_00_00_Indoor_Temperature.Height          = 17;
  Label_00_00_Indoor_Temperature.Visible         = 1;
  Label_00_00_Indoor_Temperature.Active          = 1;
  Label_00_00_Indoor_Temperature.Caption         = Label_00_00_Indoor_Temperature_Caption;
  Label_00_00_Indoor_Temperature.FontName        = Tahoma12x16_Regular;
  Label_00_00_Indoor_Temperature.Font_Color      = 0x0000;
  Label_00_00_Indoor_Temperature.VerticalText    = 0;

  Label_00_01_Indoor_Ambient_Light_CH0.OwnerScreen     = &Screen_01_INDOOR;
  Label_00_01_Indoor_Ambient_Light_CH0.Order           = 2;
  Label_00_01_Indoor_Ambient_Light_CH0.Left            = 85;
  Label_00_01_Indoor_Ambient_Light_CH0.Top             = 135;
  Label_00_01_Indoor_Ambient_Light_CH0.Width           = 9;
  Label_00_01_Indoor_Ambient_Light_CH0.Height          = 17;
  Label_00_01_Indoor_Ambient_Light_CH0.Visible         = 1;
  Label_00_01_Indoor_Ambient_Light_CH0.Active          = 1;
  Label_00_01_Indoor_Ambient_Light_CH0.Caption         = Label_00_01_Indoor_Ambient_Light_CH0_Caption;
  Label_00_01_Indoor_Ambient_Light_CH0.FontName        = Tahoma12x16_Regular;
  Label_00_01_Indoor_Ambient_Light_CH0.Font_Color      = 0x0000;
  Label_00_01_Indoor_Ambient_Light_CH0.VerticalText    = 0;

  Label_00_01_Indoor_Ambient_Light_CH1.OwnerScreen     = &Screen_01_INDOOR;
  Label_00_01_Indoor_Ambient_Light_CH1.Order           = 3;
  Label_00_01_Indoor_Ambient_Light_CH1.Left            = 85;
  Label_00_01_Indoor_Ambient_Light_CH1.Top             = 162;
  Label_00_01_Indoor_Ambient_Light_CH1.Width           = 9;
  Label_00_01_Indoor_Ambient_Light_CH1.Height          = 17;
  Label_00_01_Indoor_Ambient_Light_CH1.Visible         = 1;
  Label_00_01_Indoor_Ambient_Light_CH1.Active          = 1;
  Label_00_01_Indoor_Ambient_Light_CH1.Caption         = Label_00_01_Indoor_Ambient_Light_CH1_Caption;
  Label_00_01_Indoor_Ambient_Light_CH1.FontName        = Tahoma12x16_Regular;
  Label_00_01_Indoor_Ambient_Light_CH1.Font_Color      = 0x0000;
  Label_00_01_Indoor_Ambient_Light_CH1.VerticalText    = 0;

  Image_00_03_MP3.OwnerScreen     = &Screen_03_MP3;
  Image_00_03_MP3.Order           = 0;
  Image_00_03_MP3.Left            = 29;
  Image_00_03_MP3.Top             = 25;
  Image_00_03_MP3.Width           = 193;
  Image_00_03_MP3.Height          = 200;
  Image_00_03_MP3.Picture_Type    = 0;
  Image_00_03_MP3.Picture_Ratio   = 1;
  Image_00_03_MP3.Picture_Name    = Image_00_03_MP3_bmp;
  Image_00_03_MP3.Visible         = 1;
  Image_00_03_MP3.Active          = 1;

  Image_00_04_ACCEL.OwnerScreen     = &Screen_04_ACCEL;
  Image_00_04_ACCEL.Order           = 0;
  Image_00_04_ACCEL.Left            = 29;
  Image_00_04_ACCEL.Top             = 25;
  Image_00_04_ACCEL.Width           = 193;
  Image_00_04_ACCEL.Height          = 200;
  Image_00_04_ACCEL.Picture_Type    = 0;
  Image_00_04_ACCEL.Picture_Ratio   = 1;
  Image_00_04_ACCEL.Picture_Name    = Image_00_04_ACCEL_bmp;
  Image_00_04_ACCEL.Visible         = 1;
  Image_00_04_ACCEL.Active          = 1;

  Label_00_06_Accel_X_Axis.OwnerScreen     = &Screen_04_ACCEL;
  Label_00_06_Accel_X_Axis.Order           = 1;
  Label_00_06_Accel_X_Axis.Left            = 55;
  Label_00_06_Accel_X_Axis.Top             = 193;
  Label_00_06_Accel_X_Axis.Width           = 9;
  Label_00_06_Accel_X_Axis.Height          = 17;
  Label_00_06_Accel_X_Axis.Visible         = 1;
  Label_00_06_Accel_X_Axis.Active          = 1;
  Label_00_06_Accel_X_Axis.Caption         = Label_00_06_Accel_X_Axis_Caption;
  Label_00_06_Accel_X_Axis.FontName        = Tahoma12x16_Regular;
  Label_00_06_Accel_X_Axis.Font_Color      = 0x0000;
  Label_00_06_Accel_X_Axis.VerticalText    = 0;

  Label_00_07_Accel_Y_Axis.OwnerScreen     = &Screen_04_ACCEL;
  Label_00_07_Accel_Y_Axis.Order           = 2;
  Label_00_07_Accel_Y_Axis.Left            = 157;
  Label_00_07_Accel_Y_Axis.Top             = 193;
  Label_00_07_Accel_Y_Axis.Width           = 9;
  Label_00_07_Accel_Y_Axis.Height          = 17;
  Label_00_07_Accel_Y_Axis.Visible         = 1;
  Label_00_07_Accel_Y_Axis.Active          = 1;
  Label_00_07_Accel_Y_Axis.Caption         = Label_00_07_Accel_Y_Axis_Caption;
  Label_00_07_Accel_Y_Axis.FontName        = Tahoma12x16_Regular;
  Label_00_07_Accel_Y_Axis.Font_Color      = 0x0000;
  Label_00_07_Accel_Y_Axis.VerticalText    = 0;

  Label_00_08_Accel_Z_Axis.OwnerScreen     = &Screen_04_ACCEL;
  Label_00_08_Accel_Z_Axis.Order           = 3;
  Label_00_08_Accel_Z_Axis.Left            = 110;
  Label_00_08_Accel_Z_Axis.Top             = 51;
  Label_00_08_Accel_Z_Axis.Width           = 9;
  Label_00_08_Accel_Z_Axis.Height          = 17;
  Label_00_08_Accel_Z_Axis.Visible         = 1;
  Label_00_08_Accel_Z_Axis.Active          = 1;
  Label_00_08_Accel_Z_Axis.Caption         = Label_00_08_Accel_Z_Axis_Caption;
  Label_00_08_Accel_Z_Axis.FontName        = Tahoma12x16_Regular;
  Label_00_08_Accel_Z_Axis.Font_Color      = 0x0000;
  Label_00_08_Accel_Z_Axis.VerticalText    = 0;
}

static char IsInsideObject (unsigned int X, unsigned int Y, unsigned int Left, unsigned int Top, unsigned int Width, unsigned int Height) { // static
  if ( (Left<= X) && (Left+ Width - 1 >= X) &&
       (Top <= Y)  && (Top + Height - 1 >= Y) )
    return 1;
  else
    return 0;
}


#define GetButton(index)              CurrentScreen->Buttons[index]
#define GetLabel(index)               CurrentScreen->Labels[index]
#define GetImage(index)               CurrentScreen->Images[index]

void DrawButton(TButton *Abutton) {
unsigned int ALeft, ATop;
  if (Abutton->Visible != 0) {
    if (object_pressed == 1) {
      object_pressed = 0;
      TFT_Set_Brush(Abutton->Transparent, Abutton->Press_Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_End_Color, Abutton->Gradient_Start_Color);
    }
    else {
      TFT_Set_Brush(Abutton->Transparent, Abutton->Color, Abutton->Gradient, Abutton->Gradient_Orientation, Abutton->Gradient_Start_Color, Abutton->Gradient_End_Color);
    }
    TFT_Set_Pen(Abutton->Pen_Color, Abutton->Pen_Width);
    TFT_Rectangle(Abutton->Left, Abutton->Top, Abutton->Left + Abutton->Width - 1, Abutton->Top + Abutton->Height - 1);
    if (Abutton->VerticalText != 0)
      TFT_Set_Ext_Font(Abutton->FontName, Abutton->Font_Color, FO_VERTICAL_COLUMN);
    else
      TFT_Set_Ext_Font(Abutton->FontName, Abutton->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text_Return_Pos(Abutton->Caption, Abutton->Left, Abutton->Top);
    if (Abutton->TextAlign == _taLeft)
      ALeft = Abutton->Left + 4;
    else if (Abutton->TextAlign == _taCenter)
      ALeft = Abutton->Left + (Abutton->Width - caption_length) / 2;
    else if (Abutton->TextAlign == _taRight)
      ALeft = Abutton->Left + Abutton->Width - caption_length - 4;

    if (Abutton->TextAlignVertical == _tavTop)
      ATop = Abutton->Top + 4;
    else if (Abutton->TextAlignVertical == _tavMiddle)
      ATop = Abutton->Top + ((Abutton->Height - caption_height) / 2);
    else if (Abutton->TextAlignVertical == _tavBottom)
      ATop = Abutton->Top + (Abutton->Height - caption_height - 4);

    TFT_Write_Text(Abutton->Caption, ALeft, ATop);
  }
}

void DrawLabel(TLabel *ALabel) {
  if (ALabel->Visible != 0) {
    if (ALabel->VerticalText != 0)
      TFT_Set_Ext_Font(ALabel->FontName, ALabel->Font_Color, FO_VERTICAL_COLUMN);
    else
      TFT_Set_Ext_Font(ALabel->FontName, ALabel->Font_Color, FO_HORIZONTAL);
    TFT_Write_Text(ALabel->Caption, ALabel->Left, ALabel->Top);
  }
}

void DrawImage(TImage *AImage) {
  if (AImage->Visible != 0) {
    TFT_Ext_Image(AImage->Left, AImage->Top, AImage->Picture_Name, AImage->Picture_Ratio);
  }
}

void DrawScreen(TScreen *aScreen) {
 unsigned int order;
  unsigned short button_idx;
  TButton *local_button;
  unsigned short label_idx;
  TLabel *local_label;
  unsigned short image_idx;
  TImage *local_image;
  char save_bled;
  signed int i;

  object_pressed = 0;
  order = 0;
  button_idx = 0;
  label_idx = 0;
  image_idx = 0;
  CurrentScreen = aScreen;

  for (i = 255; i >= 0; i--)
  {
    TFT_Set_DBC_SSD1963( i );
  }
  if ((display_width != CurrentScreen->Width) || (display_height != CurrentScreen->Height)) {
    save_bled = TFT_BLED;
    TFT_BLED           = 0;
    TFT_Set_Active(Set_Index, Write_Command, Write_Data);
    TFT_Init_SSD1963_Board_43(CurrentScreen->Width, CurrentScreen->Height);
    FT5XX6_SetSize(CurrentScreen->Width, CurrentScreen->Height);
    TFT_Set_Ext_Buffer(TFT_Get_Data);
    TFT_Fill_Screen(CurrentScreen->Color);
    TFT_Set_DBC_SSD1963(255);
    display_width = CurrentScreen->Width;
    display_height = CurrentScreen->Height;
    TFT_BLED           = save_bled;
  }
  else
    TFT_Fill_Screen(CurrentScreen->Color);


  while (order < CurrentScreen->ObjectsCount) {
    if (button_idx < CurrentScreen->ButtonsCount) {
      local_button = GetButton(button_idx);
      if (order == local_button->Order) {
        button_idx++;
        order++;
        DrawButton(local_button);
      }
    }

    if (label_idx < CurrentScreen->LabelsCount) {
      local_label = GetLabel(label_idx);
      if (order == local_label->Order) {
        label_idx++;
        order++;
        DrawLabel(local_label);
      }
    }

    if (image_idx < CurrentScreen->ImagesCount) {
      local_image = GetImage(image_idx);
      if (order == local_image->Order) {
        image_idx++;
        order++;
        DrawImage(local_image);
      }
      }

    }

  for (i = 0; i <= 255; i++)
  {
    TFT_Set_DBC_SSD1963( i );
  }
}

void Get_Object(unsigned int X, unsigned int Y) {
  button_order        = -1;
  label_order         = -1;
  image_order         = -1;
  //  Buttons
  for ( _object_count = 0 ; _object_count < CurrentScreen->ButtonsCount ; _object_count++ ) {
    local_button = GetButton(_object_count);
    if (local_button->Active != 0) {
      if (IsInsideObject(X, Y, local_button->Left, local_button->Top,
                         local_button->Width, local_button->Height) == 1) {
        button_order = local_button->Order;
        exec_button = local_button;
      }
    }
  }

  //  Labels
  for ( _object_count = 0 ; _object_count < CurrentScreen->LabelsCount ; _object_count++ ) {
    local_label = GetLabel(_object_count);
    if (local_label->Active != 0) {
      if (IsInsideObject(X, Y, local_label->Left, local_label->Top,
                         local_label->Width, local_label->Height) == 1) {
        label_order = local_label->Order;
        exec_label = local_label;
      }
    }
  }

  //  Images
  for ( _object_count = 0 ; _object_count < CurrentScreen->ImagesCount ; _object_count++ ) {
    local_image = GetImage(_object_count);
    if (local_image->Active != 0) {
      if (IsInsideObject(X, Y, local_image->Left, local_image->Top,
                         local_image->Width, local_image->Height) == 1) {
        image_order = local_image->Order;
        exec_image = local_image;
      }
    }
  }

  _object_count = -1;
  if (button_order >  _object_count )
    _object_count = button_order;
  if (label_order >  _object_count )
    _object_count = label_order;
  if (image_order >  _object_count )
    _object_count = image_order;
}


void Process_TP_Press(unsigned int X, unsigned int Y) {
  exec_button         = 0;
  exec_label          = 0;
  exec_image          = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->OnPressPtr != 0) {
          exec_button->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        if (exec_label->OnPressPtr != 0) {
          exec_label->OnPressPtr();
          return;
        }
      }
    }

    if (_object_count == image_order) {
      if (exec_image->Active != 0) {
        if (exec_image->OnPressPtr != 0) {
          exec_image->OnPressPtr();
          return;
        }
      }
    }

  }
}

void Process_TP_Up(unsigned int X, unsigned int Y) {

  switch (PressedObjectType) {
    // Button
    case 0: {
      if (PressedObject != 0) {
        exec_button = (TButton*)PressedObject;
        if ((exec_button->PressColEnabled != 0) && (exec_button->OwnerScreen == CurrentScreen)) {
          DrawButton(exec_button);
        }
        break;
      }
      break;
    }
  }

  exec_label          = 0;
  exec_image          = 0;

  Get_Object(X, Y);


  if (_object_count != -1) {
  // Buttons
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->OnUpPtr != 0)
          exec_button->OnUpPtr();
        if (PressedObject == (void *)exec_button)
          if (exec_button->OnClickPtr != 0)
            exec_button->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Labels
    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        if (exec_label->OnUpPtr != 0)
          exec_label->OnUpPtr();
        if (PressedObject == (void *)exec_label)
          if (exec_label->OnClickPtr != 0)
            exec_label->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  // Images
    if (_object_count == image_order) {
      if (exec_image->Active != 0) {
        if (exec_image->OnUpPtr != 0)
          exec_image->OnUpPtr();
        if (PressedObject == (void *)exec_image)
          if (exec_image->OnClickPtr != 0)
            exec_image->OnClickPtr();
        PressedObject = 0;
        PressedObjectType = -1;
        return;
      }
    }

  }
  PressedObject = 0;
  PressedObjectType = -1;
}

void Process_TP_Down(unsigned int X, unsigned int Y) {

  object_pressed      = 0;
  exec_button         = 0;
  exec_label          = 0;
  exec_image          = 0;

  Get_Object(X, Y);

  if (_object_count != -1) {
    if (_object_count == button_order) {
      if (exec_button->Active != 0) {
        if (exec_button->PressColEnabled != 0) {
          object_pressed = 1;
          DrawButton(exec_button);
        }
        PressedObject = (void *)exec_button;
        PressedObjectType = 0;
        if (exec_button->OnDownPtr != 0) {
          exec_button->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == label_order) {
      if (exec_label->Active != 0) {
        PressedObject = (void *)exec_label;
        PressedObjectType = 2;
        if (exec_label->OnDownPtr != 0) {
          exec_label->OnDownPtr();
          return;
        }
      }
    }

    if (_object_count == image_order) {
      if (exec_image->Active != 0) {
        PressedObject = (void *)exec_image;
        PressedObjectType = 3;
        if (exec_image->OnDownPtr != 0) {
          exec_image->OnDownPtr();
          return;
        }
      }
    }

  }
}

void Check_TP() {
  if (FT5XX6_PressDetect()) {
    if (FT5XX6_GetCoordinates(&Xcoord, &Ycoord) == 0) {
    // After a PRESS is detected read X-Y and convert it to Display dimensions space
      Process_TP_Press(Xcoord, Ycoord);
      if (PenDown == 0) {
        PenDown = 1;
        Process_TP_Down(Xcoord, Ycoord);
      }
    }
  }
  else if (PenDown == 1) {
    PenDown = 0;
    Process_TP_Up(Xcoord, Ycoord);
  }
}

void Init_MCU() {
  GPIO_Digital_Output(&GPIOB_BASE, _GPIO_PINMASK_6);
  GPIO_Digital_Input(&GPIOB_BASE, _GPIO_PINMASK_7);
  GPIOB_ODR.B6 = 1;
  while (GPIOB_IDR.B7 == 0) {
    GPIOB_ODR.B6 = 0;
    Delay_us(10);
    GPIOB_ODR.B6 = 1;
    Delay_us(10);
  }
   I2C1_Init_Advanced(400000, &_GPIO_MODULE_I2C1_PB67);
}

void Init_Ext_Mem() {
  char FAT_cnt = 0;
  char Fat_Init_Flag = 0;  
  rfStartSect = 0;
  rfName      = "Mikromed.RES";

  // adjust this code to suite hw configuration
  GPIO_Digital_Output(&GPIOD_BASE, _GPIO_PINMASK_2);
  Mmc_Chip_Select = 1;

    // Initialize SDIO
    SDIO_Reset();

    SDIO_Init(_SDIO_CFG_POWER_SAVE_DISABLE | _SDIO_CFG_4_WIDE_BUS_MODE | _SDIO_CFG_CLOCK_BYPASS_DISABLE
            | _SDIO_CFG_CLOCK_RISING_EDGE | _SDIO_CFG_HW_FLOW_DISABLE, 125, &_GPIO_MODULE_SDIO_D0_D3);

    // Set pull-ups on SDIO lines
    GPIOD_PUPDRbits.PUPDR2 = 1;
    GPIOC_PUPDRbits.PUPDR8 = 1;
    GPIOC_PUPDRbits.PUPDR9 = 1;
    GPIOC_PUPDRbits.PUPDR10 = 1;
    GPIOC_PUPDRbits.PUPDR11 = 1;

    Mmc_Set_Interface(_MMC_INTERFACE_SDIO);

      if (Fat_Init_Flag == 0){
        while ((FAT32_Init() != 0) && (FAT_cnt < 5))
          FAT_cnt ++;
        if (FAT_cnt < 5){
          SDIO_Init(_SDIO_CFG_POWER_SAVE_DISABLE | _SDIO_CFG_4_WIDE_BUS_MODE | _SDIO_CFG_CLOCK_BYPASS_DISABLE
                    | _SDIO_CFG_CLOCK_RISING_EDGE | _SDIO_CFG_HW_FLOW_DISABLE, 1, &_GPIO_MODULE_SDIO_D0_D3);
          Fat_Init_Flag = 1;
        }
      }
    // Open resource file for read
    rfHandle    = FAT32_Open(rfName, 0x01);
    rfStartSect = FAT32_ClustToSect(fat32_fdesc[rfHandle]._1stClust);
}

char FT5XX6_Config()  {
  FT5XX6_SetI2CAddress(0x38);
  if (FT5XX6_IsOperational() != FT5XX6_OK)
    return  FT5XX6_FAILURE;
  FT5XX6_SetDefaultMode();
  FT5XX6_SetController(_TC_FT5X16);
  FT5XX6_SetSizeAndRotation(480,272,0);
return FT5XX6_OK;
}

void Start_TP() {
  Init_MCU();

  Init_Ext_Mem();

  InitializeTouchPanel();
  if (FT5XX6_Config() == FT5XX6_OK) {
  } else {
    while(1);
  }


  InitializeObjects();
  display_width = Screen_00_MAIN.Width;
  display_height = Screen_00_MAIN.Height;
  DrawScreen(&Screen_00_MAIN);
}
