/*
    mmb_4.h

-----------------------------------------------------------------------------

  This file is part of mikroSDK.
  
  Copyright (c) 2017, MikroElektonika - http://www.mikroe.com

  All rights reserved.

----------------------------------------------------------------------------- */

/**
        \file   mmb_4.h

- Version               :   1.0.0
- Date                  :   May 2019
- Developer             :   Milos Vidojevic

---

    Common board def inclusion for mikromedia 4 boards.

*/
/* -------------------------------------------------------------------------- */

#ifndef _MMB_4_H_
#define _MMB_4_H_

/* 
    External Board Modules.
*/

#define _MMB_MODULE_POWER           1
#define _MMB_MODULE_MICROSD         1
#define _MMB_MODULE_FLASH           1
#define _MMB_MODULE_RGBLED          1
#define _MMB_MODULE_IR              1
#define _MMB_MODULE_RF              1
#define _MMB_MODULE_MP3             1
#define _MMB_MODULE_ACCEL           1
#define _MMB_MODULE_ALS             1
#define _MMB_MODULE_TEMP            1
#define _MMB_MODULE_BUZZER          1

/* 
    Internal MCU Modules.
*/

#define _MMB_MODULE_RTC             1
#define _MMB_MODULE_USB             1

/* 
    Board definition inclusion.
*/

#ifdef __STM32__
#   include "mmb_4_stm32.h"
#endif

#endif

/* -------------------------------------------------------------------------- */
/*
    mmb_4.h

  Copyright (c) 2017, MikroElektonika - http://www.mikroe.com

  All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

3. All advertising materials mentioning features or use of this software
   must display the following acknowledgment:
   This product includes software developed by the MikroElektonika.

4. Neither the name of the MikroElektonika nor the
   names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY MIKROELEKTRONIKA ''AS IS'' AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL MIKROELEKTRONIKA BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

----------------------------------------------------------------------------- */ 