/*
    bsp_buzzer_driver.h

-----------------------------------------------------------------------------

  This file is part of mikroSDK.
  
  Copyright (c) 2017, MikroElektonika - http://www.mikroe.com

  All rights reserved.

----------------------------------------------------------------------------- */

/**
        \file   bsp_buzzer_driver.h

- Circuit               :   BUZZER
- Global Library Prefix :   BSP_BUZZER
- Version               :   1.0.1 
- Date                  :   May 2019
- Developer             :   MikroE Team

---

    Last version note :

Modified version of mikroSDK library adopted to suit needs in case of mikromedia 
development boards.

    Note :

Dependency on sound library.

*/
/* -------------------------------------------------------------------------- */

#ifndef _BSP_BUZZER_H_
#define _BSP_BUZZER_H_

#include "bsp.h"

#if ( _MMB_MODULE_BUZZER == 1 )

#ifdef __cplusplus
extern "C"{
#endif

/**
    Function initialize BUZZER module.

        \note

    Must be called before usage of any other function found in this module.

*/
void bsp_buzzer_init ( void );

/**
    Function start BUZZER.

*/
void bsp_buzzer_play ( uint32_t tone, uint32_t ms );

#ifdef __cplusplus
} // extern "C"
#endif
#endif
#endif

/* -------------------------------------------------------------------------- */
/*
    bsp_buzzer_driver.h

  Copyright (c) 2017, MikroElektonika - http://www.mikroe.com

  All rights reserved.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are met:

1. Redistributions of source code must retain the above copyright
   notice, this list of conditions and the following disclaimer.

2. Redistributions in binary form must reproduce the above copyright
   notice, this list of conditions and the following disclaimer in the
   documentation and/or other materials provided with the distribution.

3. All advertising materials mentioning features or use of this software
   must display the following acknowledgment:
   This product includes software developed by the MikroElektonika.

4. Neither the name of the MikroElektonika nor the
   names of its contributors may be used to endorse or promote products
   derived from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY MIKROELEKTRONIKA ''AS IS'' AND ANY
EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
DISCLAIMED. IN NO EVENT SHALL MIKROELEKTRONIKA BE LIABLE FOR ANY
DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
(INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
(INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

----------------------------------------------------------------------------- */
