/*
    interrupt.c

-----------------------------------------------------------------------------

  This file is part of mikroSDK.
  
  Copyright (c) 2017, MikroElektonika - http://www.mikroe.com

  All rights reserved.

----------------------------------------------------------------------------- */

/**
        \file   interrupt.c

- Version               :   1.0.0
- Date                  :   May 2019
- Developer             :   Milos Vidojevic

    Common interrupt module.

    Hints :

    - Copy file inside [project base directory]/portable.
    - Replace all "---" appearances with proper values.

*/
/* -------------------------------------------------------------------------- */

/*
    USB interrupt related functions and variables.
*/

void USB_ISR( ) iv IVT_INT_OTG_FS
{
    USBHost_IntHandler( );
}

/*
    Common initialize functions which should initialize all necessary 
    interrupts.
*/

void interrupts_enable ( void )
{
    /*
        Initialize external interrupt on CC3100 INT pin.

        NOTE : 

            Interrupt must be configured to trigger on rising edge.
    */

    
    
    /*
        Initialize global interrupts and enable vectors.

            - Enable interrupt vector for USB.
            - Enable interrupt vector for CC3100 INT pin.
    */
    
    NVIC_IntEnable( IVT_INT_OTG_FS );
    EnableInterrupts( );
}